<?php // $Id: lib-languages.inc.php,v 1.2 2001/11/13 22:53:48 ciaccia Exp $

/************************************************************************/
/* phpPgAds                                                             */
/* ========                                                             */
/*                                                                      */
/* Copyright (c) 2001 by the phpPgAds developers                        */
/* http://www.greatbridge.org/project/phppgads/                         */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/



/*********************************************************/
/* Returns available languages as array                  */
/*********************************************************/

function phpAds_AvailableLanguages()
{
	$languages = array();
	
	$langdir = opendir("../language/");
	while ($langfile = readdir($langdir))
	{
		if (is_dir("../language/$langfile"))
		{
			if (ereg("^([a-z0-9-]+)(_[a-z0-9-]+)?$", $langfile, $matches))
			{
				$languages[$langfile] = str_replace("- ", "-", 
					ucwords(str_replace("-", "- ", $matches[1]))).
					(empty($matches[2]) ? '' : ' ('.ucwords(substr($matches[2], 1)).')');
			}
		}
	}
	closedir($langdir);

	asort($languages, SORT_STRING);
	
	return $languages;
}



/*********************************************************/
/* Returns available timezones                           */
/*********************************************************/

function phpAds_AvailableTZ()
{
	global $strDefault;
	
	$tz = array("" => $strDefault);
	
	if (file_exists('/usr/share/zoneinfo') && is_dir('/usr/share/zoneinfo'))
		$basedir = '/usr/share/zoneinfo/';
	else
		return $tz;
	
	$tzdir = opendir($basedir);
	while ($tzfile = readdir($tzdir))
	{
		if (is_dir($basedir.$tzfile))
		{
			if ($tzfile[0] == '.')
				continue;
			$tzdir2 = opendir($basedir.$tzfile);			
			while ($tzfile2 = readdir($tzdir2))
			{
				if ($tzfile2[0] == '.')
					continue;
				$tz[] = "$tzfile/$tzfile2";
			}				
			closedir($tzdir2);
		}
		else
			$tz[] = $tzfile;
	}	
	closedir($tzdir);

	asort($tz, SORT_STRING);
	
	return $tz;
}

?>