<?php // $Id: lib-sessions.inc.php,v 1.4 2002/01/25 11:26:46 ciaccia Exp $

/************************************************************************/
/* phpPgAds                                                             */
/* ========                                                             */
/*                                                                      */
/* Copyright (c) 2001 by Matteo Beccati			                        */
/* http://sourceforge.net/projects/phppgads                             */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/



session_name('PHPADS_SID');

if (isset($phpAds_config['db_sessions']) && $phpAds_config['db_sessions'])
{
	session_set_save_handler (
		"phpAds_DbSessionOpen",
		"phpAds_DbSessionClose",
		"phpAds_DbSessionRead",
		"phpAds_DbSessionWrite",
		"phpAds_DbSessionDestroy",
		"phpAds_DbSessionGc");
}



/*********************************************************/
/* Fetch sessiondata from the database                   */
/*********************************************************/

function phpAds_SessionDataFetch()
{
	global $SessionID;
	
	session_start();
	$SessionID = session_id();
	
	if(!session_is_registered("Session"))
		return (false);
}



/*********************************************************/
/* Create a new sessionid                                */
/*********************************************************/

function phpAds_SessionStart()
{
	global $SessionID, $Session;
	
	session_start();

	if (!session_is_registered("Session"))
		{
		// Start a new session
		$Session = array();
		session_register("Session");
		}
		
	return ($SessionID = session_id());
}



/*********************************************************/
/* Register the data in the session array                */
/*********************************************************/

function phpAds_SessionDataRegister($key, $value='')
{
	global $Session;
	
	phpAds_SessionStart();
	
	if (is_array($key) && $value=='')
	{
		for (reset($key);$name=key($key);next($key))
		{
			$Session[$name] = $key[$name];
		}
	}
	else
		$Session[$key] = $value;

	session_register("Session");
}



/*********************************************************/
/* Store the session array in the database               */
/*********************************************************/

function phpAds_SessionDataStore()
{
// Do nothing :)
}



/*********************************************************/
/* Destroy the current session                           */
/*********************************************************/

function phpAds_SessionDataDestroy()
{
	session_start();
	session_destroy();
}



/*********************************************************/
/* PHP4 Database session handlers                        */
/*********************************************************/

function phpAds_DbSessionOpen()
{
	global $phpAds_db_link;
	
	return $phpAds_db_link ? true : false;
}



function phpAds_DbSessionClose()
{
	return true;
}



function phpAds_DbSessionRead($sessionid)
{
	global $phpAds_config;
	
	$sessiondata = phpAds_DbResult(phpAds_DbQuery("
		SELECT
			sessiondata
		FROM
			".$phpAds_config['tbl_session']."
		WHERE
			sessionid = '$sessionid'
		"), 0, 0);
	
	return $sessiondata ? $sessiondata : '';
}



function phpAds_DbSessionWrite($sessionid, $sessiondata)
{
	global $phpAds_config;

	$sessiondata = addslashes($sessiondata);

	$res = phpAds_DbQuery("
		UPDATE
			".$phpAds_config['tbl_session']."
		SET
			sessiondata = '$sessiondata',
			lastused = NOW()
		WHERE
			sessionid = '$sessionid'
	");
	
	if (!phpAds_DbAffectedRows($res))
	{
		$res = phpAds_DbQuery("
			INSERT INTO ".$phpAds_config['tbl_session']."
				(sessionid, sessiondata, lastused)
			VALUES
				('$sessionid', '$sessiondata', NOW())
		");
	}

	return $res ? true : false;
}



function phpAds_DbSessionDestroy($sessionid)
{
	global $phpAds_config;

	$res = phpAds_DbQuery("
		DELETE FROM
			".$phpAds_config['tbl_session']."
		WHERE
			sessionid = '$sessionid'
	");

	return $res ? true : false;
}



function phpAds_DbSessionGc($maxlifetime)
{
	global $phpAds_config;

	$res = phpAds_DbQuery("
		DELETE FROM
			".$phpAds_config['tbl_session']."
		WHERE
			UNIX_TIMESTAMP(lastused) > UNIX_TIMESTAMP(NOW()) + $maxlifetime
	");

	return true;
}


?>